################################################################################
# Required Variables
################################################################################

variable "name" {
  type        = string
  description = "The full name of this VPC."
}

variable "owner" {
  type        = string
  description = "The email address of the technical/business owner for this asset."
}

variable "company" {
  type        = string
  description = "The name of the company that owns this asset."
}

variable "ipv4_cidr" {
  type        = string
  description = "The IPv4 CIDR range for the VPC."
}

################################################################################
# Optional Variables
################################################################################

variable "tenancy" {
  type        = string
  default     = "default"
  description = "Tenancy of instances spun up within this VPC."
}

variable "nau_metrics" {
  type        = bool
  default     = false
  description = "Indicates whether Network Address Usage metrics are enabled for your VPC."
}

################################################################################

variable "dns_support" {
  type        = bool
  default     = true
  description = "Whether or not the VPC has DNS support."
}

variable "dns_hostnames" {
  type        = bool
  default     = true
  description = "Whether or not the VPC has DNS hostname support."
}

################################################################################

variable "kubernetes_shared" {
  type        = bool
  default     = true
  description = "A flag to specify if or not Kubernetes is sharing this VPC with other resources."
}

variable "kubernetes_type" {
  type        = string
  default     = "none"
  description = "Kubernetes cluster type. Must be 'eks', 'kops' or 'none'."

  validation {
    condition     = contains(["eks", "kops", "none"], var.kubernetes_type)
    error_message = "Kubernetes cluster type must either be 'eks', 'kops' or 'none'."
  }
}

variable "kubernetes_cluster" {
  type        = string
  default     = null
  description = "The full name of the Kubernetes cluster that will be using this VPC. If unspecified this is autogenerated based on 'kubernetes_type'."
}

################################################################################

variable "kubernetes_eks_class" {
  type        = string
  default     = "eks"
  description = "The identifier for the EKS cluster within the VPC. Ignored if 'kubernetes_cluster' is specified or 'kubernetes_type' is not 'eks'."
}

################################################################################

variable "kubernetes_kops_gossip_domain" {
  type        = string
  default     = "k8s.local"
  description = "The Kubernetes gossip domain suffix to be used if 'route53_private_zone_create' is 'false', 'kubernetes_cluster' has not been expicitally set and 'kubernetes_type' is 'kops'."
}

################################################################################
# Locals
################################################################################

locals {
  kubernetes_cluster = local.kubernetes_enabled ? coalesce(var.kubernetes_cluster, local.kubernetes_clusters[var.kubernetes_type]) : null
  kubernetes_enabled = var.kubernetes_type != "none"

  kubernetes_clusters = {
    "eks"  = format("%s-%s", var.name, var.kubernetes_eks_class)
    "kops" = var.route53_private_zone_create ? coalesce(var.route53_private_zone_name, format("%s.%s", var.name, var.route53_private_zone_base)) : format("%s.%s", var.name, var.kubernetes_kops_gossip_domain)
  }

  kubernetes_tags = local.kubernetes_enabled ? {
    (format("kubernetes.io/cluster/%s", local.kubernetes_cluster)) = var.kubernetes_shared ? "shared" : "owned"
  } : {}
}

################################################################################
# Resources
################################################################################

resource "aws_vpc" "scope" {
  cidr_block                           = var.ipv4_cidr
  instance_tenancy                     = var.tenancy
  enable_dns_support                   = var.dns_support
  enable_dns_hostnames                 = var.dns_hostnames
  enable_network_address_usage_metrics = var.nau_metrics
  assign_generated_ipv6_cidr_block     = true

  tags = merge(
    {
      "Name"    = var.name
      "Owner"   = var.owner
      "Region"  = data.aws_region.scope.name
      "Company" = var.company
    },
    local.kubernetes_tags
  )
}

################################################################################
# Outputs
################################################################################

output "owner" {
  value = var.owner
}

output "company" {
  value = var.company
}

################################################################################

output "kubernetes_tags" {
  value = local.kubernetes_tags
}

output "kubernetes_type" {
  value = var.kubernetes_type
}

output "kubernetes_shared" {
  value = var.kubernetes_shared
}

output "kubernetes_cluster" {
  value = local.kubernetes_cluster
}

output "kubernetes_enabled" {
  value = local.kubernetes_enabled
}

################################################################################

output "kubernetes_eks_class" {
  value = var.kubernetes_eks_class
}

################################################################################

output "kubernetes_kops_gossip_domain" {
  value = var.kubernetes_kops_gossip_domain
}

################################################################################

output "id" {
  value = aws_vpc.scope.id
}

output "name" {
  value = aws_vpc.scope.tags.Name
}

output "tenancy" {
  value = aws_vpc.scope.instance_tenancy
}

output "ipv4_cidr" {
  value = aws_vpc.scope.cidr_block
}

output "ipv6_cidr" {
  value = aws_vpc.scope.ipv6_cidr_block
}

output "dns_support" {
  value = aws_vpc.scope.enable_dns_support
}

output "nau_metrics" {
  value = aws_vpc.scope.enable_network_address_usage_metrics
}

output "dns_hostnames" {
  value = aws_vpc.scope.enable_dns_hostnames
}

output "ipv6_association_id" {
  value = aws_vpc.scope.ipv6_association_id
}

output "main_route_table_id" {
  value = aws_vpc.scope.main_route_table_id
}

output "default_route_table_id" {
  value = aws_vpc.scope.default_route_table_id
}

output "default_network_acl_id" {
  value = aws_vpc.scope.default_network_acl_id
}

output "default_security_group_id" {
  value = aws_vpc.scope.default_security_group_id
}

################################################################################
